import React from 'react';
import { SxPalette } from '../../hoc/withSx/palette';
import { SxPseudoProps } from '../../hoc/withSx/pseudo';
import { SxSizing } from '../../hoc/withSx/sizing';
import { SxSpace } from '../../hoc/withSx/space';
import { SxTypography } from '../../hoc/withSx/typography';
import { ThemeOptions } from './../../components/theme/ThemeContext';
type UseStyleProps = {
    [key: string]: any;
};
type UseStyleResult = {
    [key: string]: string;
};
type UseStyleOption = {
    noSx?: boolean;
    idLength?: number;
};
export type BaseCSSProperties = React.CSSProperties | SxSpace | SxPalette | SxSizing | SxTypography | {
    shadow?: number | string;
} | SxPseudoProps;
type RootCallbackResult = {
    [key in keyof React.CSSProperties | keyof SxPalette | keyof SxSpace | keyof SxPalette | keyof SxSizing | keyof SxTypography]: any;
};
type RootCallback = (props: any) => RootCallbackResult;
export type SelectorCSSProperties = {
    [key: string]: BaseCSSProperties;
};
type SelectorCSSPropertiesCallback = {
    [key: string]: RootCallback;
};
type CSSPropertiesCallback = {
    [key in keyof BaseCSSProperties]: (props: any) => any;
};
export type MakeStyleContent = BaseCSSProperties | RootCallback | CSSPropertiesCallback | SelectorCSSProperties | SelectorCSSPropertiesCallback;
export type MakeStyleCallback = (theme: ThemeOptions) => {
    [key: string]: MakeStyleContent;
};
export type MakeStyleParam = {
    [key: string]: MakeStyleContent;
} | MakeStyleCallback;
export declare function makeStyles(params: MakeStyleParam, prefixClass?: string): (props?: UseStyleProps, options?: UseStyleOption) => UseStyleResult;
export default makeStyles;
